<?php

// load lib
$loader = require __DIR__ . '/../vendor/autoload.php';

// autoloading class cache router
if (is_dir(__DIR__ . '/../storage/php/router')) {
    $loader->addPsr4('', __DIR__ . '/../storage/php/router');
}

(new Dotenv\Dotenv(__DIR__.'/../'))->load();

ini_set('mbstring.language', 'UTF-8');
ini_set('default_charset', 'UTF-8');
ini_set('mbstring.detect_order', 'auto');
/**
 * Config PHP
 */
if (!defined('DS')) {
    define('DS', DIRECTORY_SEPARATOR);
}

$basePath = dirname(dirname(__FILE__));

// Mode "deployer"
$pattern = "/\/releases\/(\d+)$/";
$replacement = "/current";
$basePath = preg_replace($pattern, $replacement, $basePath);

//définition du dossier www
if (!defined('ROOT')) {
    define('ROOT', dirname($basePath));
}

//définition du dossier de l'application
if (!defined('APP_DIR')) {
    define('APP_DIR', basename($basePath));
}

//définition du dossier ou site
if (!defined('SITE_DIR')) {
    define('SITE_DIR', ROOT . DS . APP_DIR . DS);
}

if (!defined('BACK_DIR')) {
    define('BACK_DIR', SITE_DIR . 'back' . DS);
}

if (!defined('MEDIA_DIR')) {
    define('MEDIA_DIR', SITE_DIR . 'media' . DS);
}

if (!defined('STORAGE_DIR')) {
    define('STORAGE_DIR', SITE_DIR . 'storage' . DS);
}

if (!defined('LOGS_DIR')) {
    define('LOGS_DIR', STORAGE_DIR . 'logs' . DS);
}

if (!defined('WEB_DIR')) {
    define('WEB_DIR', SITE_DIR . 'web' . DS);
}

if (empty($_SERVER['HTTP_HOST'])) {
    $_SERVER['HTTP_HOST'] = getenv('APP_URL');
}

if (getenv('URL_OVERRIDE')) {
    $_SERVER['HTTP_HOST'] = getenv('URL_OVERRIDE');
}

if (!defined('SITE_URL') && !empty($_SERVER['HTTP_HOST']) && !empty($_SERVER['REQUEST_SCHEME'])) {
    define('SITE_URL', $_SERVER['REQUEST_SCHEME'] . '://' . $_SERVER['HTTP_HOST'] . '/');
    define('BACK_URL', SITE_URL . 'back/');
}


// AUTHOR
define('AUTHOR_NAME', 'Dedi Agency');
define('AUTHOR_URL', 'https://www.dedi-agency.com/');
define('AUTHOR_MAIL_SUPPORT', 'support@dedi-agency.com');

define('DELAI_PAR_DEFAUT', 2); // delai de livraison par defaut en nombre de jours

// Register route annotation of Symfony component routing
\Doctrine\Common\Annotations\AnnotationRegistry::registerFile(
    __DIR__ . '/../vendor/symfony/routing/Annotation/Route.php'
);

Application::bootIfNotBooted();
