<?php

use Phinx\Migration\AbstractMigration;
use Phinx\Db\Adapter\MysqlAdapter;

class AddPays extends AbstractMigration
{
    public function change()
    {
        $this
            ->table("pays", ['id' => false, 'primary_key' => ["pays_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('pays_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('pays_iso_code_2', 'char', ['null' => false, 'default' => '', 'limit' => 2, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'pays_id'])
            ->addColumn('pays_iso_code_3', 'char', ['null' => false, 'default' => '', 'limit' => 3, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'pays_iso_code_2'])
            ->addColumn('zone_id', 'integer', ['null' => true, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'pays_iso_code_3', 'signed' => false])
            ->addForeignKey('zone_id', 'zone', 'zone_id', array(
                'delete' => 'SET NULL',
                'update' => 'CASCADE'
            ))
            ->addIndex(['zone_id'], ['name' => "zone_id", 'unique' => false])
            ->create();

        $this
            ->table("pays_nom", ['id' => false, 'primary_key' => ["pays_nom_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('pays_nom_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('pays_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'pays_nom_id', 'signed' => false])
            ->addColumn('langue_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'pays_id', 'signed' => false])
            ->addColumn('pays_nom_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'langue_id'])
            ->addForeignKey('pays_id', 'pays', 'pays_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('langue_id', 'langue', 'langue_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addIndex(['pays_id', 'langue_id'], ['name' => "langue_id_2", 'unique' => true])
            ->addIndex(['pays_id'], ['name' => "pays_id", 'unique' => false])
            ->addIndex(['langue_id'], ['name' => "langue_id", 'unique' => false])
            ->create();
    }
}
