<?php

use Phinx\Migration\AbstractMigration;
use Phinx\Db\Adapter\MysqlAdapter;

class AddAdresse extends AbstractMigration
{
    public function change()
    {
        $this
            ->table("adresse", ['id' => false, 'primary_key' => ["adresse_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('adresse_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('adresse_libelle', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'adresse_id'])
            ->addColumn('client_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'adresse_libelle', 'signed' => false])
            ->addColumn('civilite_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'client_id', 'signed' => false])
            ->addColumn('adresse_societe', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'civilite_id'])
            ->addColumn('adresse_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'adresse_societe'])
            ->addColumn('adresse_prenom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'adresse_nom'])
            ->addColumn('adresse_rue', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'adresse_prenom'])
            ->addColumn('adresse_rue2', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'adresse_rue'])
            ->addColumn('adresse_cp', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'adresse_rue2'])
            ->addColumn('adresse_ville', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'adresse_cp'])
            ->addColumn('adresse_etat', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'adresse_ville'])
            ->addColumn('adresse_telephone', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'adresse_etat'])
            ->addColumn('pays_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'adresse_telephone', 'signed' => false])
            ->addColumn('adresse_default', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_TINY, 'precision' => 3, 'after' => 'pays_id'])
            ->addForeignKey('client_id', 'client', 'client_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('civilite_id', 'civilite', 'civilite_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('pays_id', 'pays', 'pays_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addIndex(['client_id'], ['name' => "client_id", 'unique' => false])
            ->addIndex(['pays_id'], ['name' => "pays_id", 'unique' => false])
            ->addIndex(['civilite_id'], ['name' => "civilite_id", 'unique' => false])
            ->addIndex(['adresse_default'], ['name' => "adresse_default", 'unique' => false])
            ->create();
    }
}
