<?php

namespace Auth;

use Symfony\Component\EventDispatcher\Event;
use Symfony\Component\HttpFoundation\RedirectResponse;

use Application;

class CustomerAuth {

    public function __construct()
    {

    }

    /**
     * Function for register callback when we need check role 'cutomer'
     *
     * @param Event $event
     */
    public function register(Event $event)
    {
        $event->getAuth()
            ->register('customer', array('Auth\\CustomerAuth', 'handle'));
    }

    /**
     *
     * @param Auth $auth
     * @param string $roleName
     *
     * @return bool|RedirectResponse
     */
    public function handle(Auth $auth, $roleName)
    {
        $request = $auth->getRequest();
        $route = $request->get('_route');

        // TODO : mettre l'url de la page dans le flashbag pour redirgier ensuite

        $queryString = array();
        $routesProcess = array('order', 'coordonnees');
        if (in_array($route, $routesProcess)) {
            $queryString['origin'] = 'panier';
        }

        $clientId = $request->getSession()->get('client_id');
        if (empty($clientId)) {
            return new RedirectResponse(
                Application::getRouter()->generate('login', $queryString)
            );
        }

        return true;
    }

}
