<?php

namespace DebugBar\DataCollector;

class RouterDataCollector extends DataCollector implements Renderable
{
    public function collect()
    {
        $data = array();

        $routes = \Application::getRouter()->getRouter()->getRouteCollection()->all();
        foreach ($routes as $key => $route) {
            $dataForRoute = array();
            $dataForRoute['path'] = $route->getPath();
            $defaults = $route->getDefaults();
            $dataForRoute['controller'] = $defaults['_controller'];
            $dataForRoute['action'] = $defaults['_action'];
            $dataForRoute['defaults'] = $route->getDefaults();
            $dataForRoute['requirements'] = $route->getRequirements();

            $methods = $route->getMethods();
            if (!empty($methods)) {
                $dataForRoute['methods'] = $methods;
            }

            $data[$key] = $dataForRoute;
        }

        foreach ($data as $k => $v) {
            if (!is_string($v)) {
                $v = $this->getDataFormatter()->formatVar($v);
            }
            $data[$k] = $v;
        }

        return $data;
    }

    public function getName()
    {
        return 'Routes';
    }

    public function getWidgets()
    {
        $name = $this->getName();
        return array(
            "$name" => array(
                "icon" => "gear",
                "widget" => "PhpDebugBar.Widgets.VariableListWidget",
                "map" => "$name",
                "default" => "{}"
            )
        );
    }
}
