<?php

namespace Event;

use Symfony\Component\EventDispatcher\Event;
use Symfony\Component\HttpFoundation\Request;
use Template;

/**
 * Class TemplateEvent
 * @package Event
 */
class TemplateEvent extends Event
{
    const PRE_RENDER = 'template.pre_render';
    const POST_RENDER = 'template.post_render';

    /**
     * @var Template
     */
    protected $engine;

    /**
     * @var Request
     */
    protected $request;

    /**
     * TemplateEvent constructor.
     * @param Template $engine
     * @param Request $request
     */
    public function __construct(Template $engine, Request $request)
    {
        $this->engine = $engine;
        $this->request = $request;
    }

    /**
     * @return Template
     */
    public function getEngine()
    {
        return $this->engine;
    }

    /**
     * @return Request
     */
    public function getRequest()
    {
        return $this->request;
    }

}