<?php

declare(strict_types=1);

/**
 * Class Localization
 */
final class LangueLocalization implements LocalizationInterface
{
    /**
     * @var Langue
     */
    private $langue;

    /**
     * @param Langue $langue
     */
    public function __construct(Langue $langue)
    {
        $this->setLangue($langue);
    }

    /**
     * @return string[] locales used to prefix urls
     */
    public function getLocales(): array
    {
        return array_map(function (array $langue) {
            return strtolower($langue['langue_ini']);
        }, $this->langue()->get());
    }

    /**
     * @return Langue
     */
    private function langue()
    {
        return $this->langue;
    }

    /**
     * @param Langue $langue
     *
     * @return LangueLocalization
     */
    private function setLangue(Langue $langue)
    {
        $this->langue = $langue;
        return $this;
    }

}