<?php

/**
 * Class Tools
 */
class Tools
{

    /**
     * @return bool
     * savoir si l'appel a un script php est fait en ajax
     */
    static function isAJAX()
    {
        return (!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest');
    }

    static function dateFRtoEN($myDate)
    {
        $date = explode(' ', $myDate);
        $arrDate = explode('/', $date[0]);

        $date[1] = (empty($date[1])) ? '00:00' : $date[1];

        return ($arrDate[2] . '-' . $arrDate[1] . '-' . $arrDate[0] . ' ' . $date[1]);
    }

    static function dateENtoFR($myDate)
    {
        $date = explode(' ', $myDate);
        $arrDate = explode('-', $date[0]);

        $date[1] = (empty($date[1])) ? '00:00' : $date[1];

        return ($arrDate[2] . '/' . $arrDate[1] . '/' . $arrDate[0] . ' ' . $date[1]);
    }

    static function valideAdresseCommande($adr)
    {
        return (!empty($adr['civilite_nom']) && !empty($adr['adresse_nom']) && !empty($adr['adresse_prenom']) && !empty($adr['adresse_rue']) && !empty($adr['adresse_ville']) && !empty($adr['adresse_cp']) && !empty($adr['pays_id']));
    }

    static function valideCpLivraisonPays($cp, $pays)
    {
        $return = true;

        // check si cp dom-tom et pays France
        $domTom = array(97, 98);
        $debutCp = substr($cp, 0, 2);
        if (in_array($debutCp, $domTom) && $pays == Pays::FRANCE) {
            $return = false;
        }
        //--
        return $return;
    }

    public static function isDediServicesIp()
    {
        return (in_array(getenv('APP_ENV'), ['dev', 'local'])) ?
            true : (getenv('DEBUG_REMOTE_ADDR') == $_SERVER['REMOTE_ADDR']);
    }

    public static function transformUrlWithAuthHttp($url)
    {
        $login = 'to';
        $passwd = 'define';

        if (getenv('APP_ENV') == 'preprod') {
            $infosUrl = parse_url($url, PHP_URL_HOST);
            $infosUrlWithAuth = $login . ':' . $passwd. '@' . parse_url($url, PHP_URL_HOST);
            $url = str_replace($infosUrl, $infosUrlWithAuth, $url);
        }

        return $url;
    }

    /**
     * @param $var
     */
    public static function dediLog($var)
    {
        if (Tools::isDediServicesIp()) {
            echo '<pre>';
            print_r($var);
            echo '</pre>';
        }
    }


    public static function escapeDataToSql(&$vars, $key = '')
    {
        if (!get_magic_quotes_gpc()) {
            if (is_array($vars)) {
                foreach ($vars as $key => &$value) {
                    Tools::escapeDataToSql($value, $key);
                }
            } else {
                // $sanitize = Sanitize::getInstance();
                /*if (!empty($sanitize[$key])) {
                    $vars = filter_var($vars, $sanitize[$key]);
                } else {*/
                    $vars = SiteSQL::getInstance()->db->real_escape_string($vars);
                // }
            }
        }
    }

    static function getHighParent($categorie_id)
    {
        $categorie = new Categorie;
        $arrCateg = array();
        list($arrCateg) = $categorie->get(array('categorie_id' => $categorie_id));
        if (!empty($arrCateg['parent_id']) && $arrCateg['parent_id'] != 'NULL') {
            return self::getHighParent($arrCateg['parent_id']);
        } else {
            return $arrCateg;
        }
    }

    static function redirection301($url) {
        header("Status: 301 Moved Permanently", false, 301);
        header("Location: $url");
        exit();
    }

    static function parseHttpAccept($httpAccept)
    {
        $strAccept = explode(';', $httpAccept);
        $accept = explode(',', $strAccept[0]);
        return array_map('trim', $accept);
    }

    static function getContentTypeRequest()
    {
        $accept = Tools::parseHttpAccept($_SERVER['HTTP_ACCEPT']);
        return (in_array('application/javascript', $accept)) ? 'application/javascript' : 'text/html';
    }

    /**
     * @param $arr
     * @param $key
     * @param $value
     * @return array
     */
    static function formatAssoc($arr, $key, $value)
    {
        $return = array();
        foreach ($arr as $a) {
            $return[$a[$key]] = $a[$value];
        }

        return $return;
    }

    static public function extractValue($key, $array)
    {
        $return = array();
        foreach ($array as $a) {
            $return[] = $a[$key];
        }

        return array_filter($return);
    }

    /**
     * @param $text
     * @return mixed|string
     */
    static function parseURL($text)
    {


        $text = trim(mb_strtolower($text));

        $table = array(
            'Š' => 'S', 'š' => 's', 'Đ' => 'D', 'đ' => 'd', 'Ž' => 'Z', 'ž' => 'z', 'Č' => 'C', 'č' => 'c', 'Ć' => 'C', 'ć' => 'c',
            'À' => 'A', 'Á' => 'A', 'Â' => 'A', 'Ã' => 'A', 'Ä' => 'A', 'Å' => 'A', 'Æ' => 'A', 'Ç' => 'C', 'È' => 'E', 'É' => 'E',
            'Ê' => 'E', 'Ë' => 'E', 'Ì' => 'I', 'Í' => 'I', 'Î' => 'I', 'Ï' => 'I', 'Ñ' => 'N', 'Ò' => 'O', 'Ó' => 'O', 'Ô' => 'O',
            'Õ' => 'O', 'Ö' => 'O', 'Ø' => 'O', 'Ù' => 'U', 'Ú' => 'U', 'Û' => 'U', 'Ü' => 'U', 'Ý' => 'Y', 'Þ' => 'B', 'ß' => 'Ss',
            'à' => 'a', 'á' => 'a', 'â' => 'a', 'ã' => 'a', 'ä' => 'a', 'å' => 'a', 'æ' => 'a', 'ç' => 'c', 'è' => 'e', 'é' => 'e',
            'ê' => 'e', 'ë' => 'e', 'ì' => 'i', 'í' => 'i', 'î' => 'i', 'ï' => 'i', 'ð' => 'o', 'ñ' => 'n', 'ò' => 'o', 'ó' => 'o',
            'ô' => 'o', 'õ' => 'o', 'ö' => 'o', 'ø' => 'o', 'ù' => 'u', 'ú' => 'u', 'û' => 'u', 'ý' => 'y', 'þ' => 'b',
            'ÿ' => 'y', 'Ŕ' => 'R', 'ŕ' => 'r', ' - ' => '-', ' ' => '-', '&' => 'et', 'œ' => 'oe'
        );

        $text = strtr($text, $table);

        $text = preg_replace('/[^a-z0-9-]/', '', $text);

        return $text;
    }

    /**
     * @param $html
     * @return mixed|string
     *
     * Transforme un code html en txt non formaté
     */
    static function htmlToTxt($html) {

        $txt = str_replace(array("\n", "\r"), "", $html);
        $txt = str_replace(array('<br/>', '<br>', '<br />'), "\n", $txt);
        $txt = strip_tags($txt);
        $txt = html_entity_decode($txt, ENT_COMPAT, 'UTF-8');

        return $txt;
    }

    static public function setDefault($table, $table_base, $id, $default, $table_id = null) {

        $con = SiteSQL::getInstance();

        if (is_null($default)) {
            $zeID = $id;
        } else {

            $select = $table . '_id';
            $champ = $table_base . '_id';

            $sql = "SELECT " . $select;
            $sql.=" FROM " . $table;
            $sql.=" WHERE " . $champ . " = '" . $id . "'";

            $con = SiteSQL::getInstance();
            $con->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);

            if ($con->record && count($con->record) > 0)
                $zeID = $con->record[$select];
        }

        //this table_id variable is used if it is desired to set a specific entry as default
        if ($table_id) {
            $zeID = $table_id;
        }

        // Si on met sp�cifiquement cette ligne par d�fault, on update tout � 0 et on la met a 1.
        if ($default == 1) {

            $sql = "UPDATE " . $table . " SET " . $table . "_default = '0' WHERE " . $table_base . "_id = '" . $id . "'";
            $con->query($sql);
            $sql = "UPDATE " . $table . " SET " . $table . "_default = '1' WHERE " . $table . "_id = '" . $zeID . "'";
            $con->query($sql);
        }
        // Si default est a 0 ou NULL, alors...
        else {

            //On regarde s'il existe une ligne par default
            $sql = "SELECT " . $table . "_id FROM " . $table . " WHERE " . $table_base . "_id = '" . $zeID . "' AND " . $table . "_default = '1'";
            $con->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
            //echo $sql;
            $num_rows = count($con->record);

            // Si non... on met la premiere ligne par defaut.
            if ($num_rows == 0) {

                $sql2 = "SELECT " . $table . "_id FROM " . $table . " WHERE " . $table_base . "_id = '" . $zeID . "'";
                //echo $sql2;
                $con->query($sql2, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
                $num_rows2 = count($con->record);
                // Si oui... alors on fait keud
                if ($num_rows2 > 0) {
                    $sql = "UPDATE " . $table . " SET " . $table . "_default = '1' WHERE " . $table . "_id = '" . $con->record[0][$table . "_id"] . "'";
                    $con->query($sql);
                }
            }
        }
    }

    /**
     * @param $nameFile
     * @param $dir
     * @return bool|string
     */
    static public function getPathFile($nameFile, $dir)
    {
        $arrFiles = scandir($dir);
        $nameFile = strtolower($nameFile);

        foreach ($arrFiles as $f) {
            if ($f == '.' || $f == '..') {
                continue;
            }

            if (is_dir($dir . $f)) {
                $rep = self::getPathFile($nameFile, $dir . $f . DS);
                if ($rep != false) {
                    return $rep;
                }
            } elseif (is_file($dir . $f)) {
                $fLower = strtolower($f);
                if ($fLower == $nameFile) {
                    return $dir . $f;
                }
            }
        }

        return false;

    }

    public static function dedibug($var)
    {
        if (Tools::isDediServicesIp()) {
            echo '<div style="background-color:#FFFFFF;margin-bottom:10px;font-size:12px;padding:10px;text-align:left ! important;">';
            if (is_array($var)) {
                echo '<pre>';
                print_r($var);
                echo '</pre>';
            } elseif (strpos($var, 'SELECT') !== false || strpos($var, 'INSERT INTO') !== false || strpos($var, 'UPDATE') !== false || strpos($var, 'DELETE FROM') !== false) {
                $sql = $var;
                $sql = preg_replace("#as ([a-zA-Z0-9-_]+)#is", "as $1<br/>", $sql);
                $sql = preg_replace("#(FROM|JOIN) (\()?([a-zA-Z0-9-_]+) ([a-zA-Z0-9-_]+)(\))?#is", "$1 $2<strong>$3</strong> <span style='font-style:italic'>$4</span>$5", $sql);
                $sql = preg_replace("#([a-zA-Z0-9-_]+\.)#is", "<span style='font-style:italic'>$1</span>", $sql);
                $motclefsql = array('SELECT', 'FROM', 'LEFT JOIN', 'INNER JOIN', 'WHERE', 'HAVING', 'GROUP BY', 'ORDER', 'LIMIT', 'TABLE', 'ON', 'TRUNCATE', 'DELETE', 'DROP');
                foreach ($motclefsql as $mot) {
                    $sql = str_replace($mot, "<br/><span style='color:#FF0000'>" . $mot . "</span>", $sql);
                }
                $motclefsql = array('AND ', 'OR ');
                foreach ($motclefsql as $mot) {
                    $sql = str_replace($mot, "<span style='color:#CB00D6'>" . $mot . "</span>", $sql);
                }
                echo $sql . '<br/><br/>';
            } else {
                var_dump($var);
            }
            echo '</div>';
        }
    }

    public static function recursiveRemoveDir($dir)
    {
        if (is_dir($dir)) {
            $elements = scandir($dir);
            foreach ($elements as $element) {
                if ($element != "." && $element != "..") {
                    if (filetype($dir . "/" . $element) == "dir") self::recursiveRemoveDir($dir . "/" . $element); else unlink($dir . "/" . $element);
                }
            }
            reset($objects);
            rmdir($dir);
        }
    }

    /**
     * @param $date
     * @return int
     */
    static public function dateCheckFree($date)
    {

        // Dimanche(0) ou Samedi(6)
        if (date('w', $date) == 0 || date('w', $date) == 6) {
            return 1;
        }

        $jour = date('d', $date);
        $mois = date('m', $date);
        $annee = date('Y', $date);

        if ($jour == 1 && $mois == 1)
            return 1; // 1er janvier
        if ($jour == 1 && $mois == 5)
            return 1; // 1er mai
        if ($jour == 8 && $mois == 5)
            return 1; // 5 mai
        if ($jour == 14 && $mois == 7)
            return 1; // 14 juillet
        if ($jour == 15 && $mois == 8)
            return 1; // 15 aout
        if ($jour == 1 && $mois == 11)
            return 1; // 1er novembre
        if ($jour == 11 && $mois == 11)
            return 1; // 11 novembre
        if ($jour == 25 && $mois == 12)
            return 1; // 25 décembre


        // Pâques
        if(function_exists('easter_date')){
            $date_paques = easter_date($annee);
            $jour_paques = date('d', $date_paques);
            $mois_paques = date('m', $date_paques);
            if ($jour_paques == $jour && $mois_paques == $mois) {
                return 1;
            }

            // Ascension
            $date_ascension = mktime(date("H", $date_paques), date("i", $date_paques), date("s", $date_paques), date("m", $date_paques), date("d", $date_paques) + 39, date("Y", $date_paques));
            if (date('d', $date_ascension) == $jour && date('m', $date_ascension) == $mois) {
                return 1;
            }
            // Pentecote
            $date_pentecote = mktime(date("H", $date_paques), date("i", $date_paques), date("s", $date_paques), date("m", $date_paques), date("d", $date_paques) + 50, date("Y", $date_paques));
            if (date('d', $date_pentecote) == $jour && date('m', $date_pentecote) == $mois) {
                return 1;
            }
        }

        return 0;
    }

    /**
     * @param string $htmlTxt
     * @return string
     */
    public static function sanitizeHTML($htmlTxt){
        $newText = strip_tags($htmlTxt);
        $newText = preg_replace('#\s{2,}#', '\s', $newText);
        $newText = preg_replace('#\s{2,}#', '\s', $newText);
        return $newText;
    }

    /**
     * @param float $float
     * @param float $multiplier
     * @return float
     */
    public static function multiplyBy($float, $multiplier){

        return (float)$float * (float)$multiplier;
    }

    /**
     * @param $plain
     * @return string
     */
    public static function encryptPassword($plain) {
        if (getenv('DISABLE_CRYPT_PASSWORD')) {
            return $plain;
        }

        $password = '';

        for ($i = 0; $i < 10; $i++) {
            $password .= self::getRand();
        }

        $salt = substr(md5($password), 0, 2);

        $password = md5($salt . $plain) . ':' . $salt;

        return $password;
    }

    /**
     * @param null $min
     * @param null $max
     * @return int|null
     *
     * genere une chaine aleatoire
     */
    public static function getRand($min = null, $max = null) {

        static $seeded;

        if (!isset($seeded)) {
            mt_srand((double) microtime() * 1000000);
            $seeded = true;
        }

        if (isset($min) && isset($max)) {
            if ($min >= $max) {
                return $min;
            } else {
                return mt_rand($min, $max);
            }
        } else {
            return mt_rand();
        }
    }

    /**
     * @param $plain
     * @param $encrypted
     * @return bool
     */
    public static function passwordValidate($plain, $encrypted)
    {
        if (!getenv('DISABLE_CRYPT_PASSWORD')) {
            $stack = explode(':', $encrypted);
            if (sizeof($stack) != 2)
                return false;

            if (md5($stack[1] . $plain) == $stack[0])
                return true;

            return false;
        } else {
            if ($plain == $encrypted)
                return true;
            else
                return false;
        }
    }
}