<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    <title>{$SITE_NAME}</title>

    <!-- Bootstrap -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
    <link href="https://fonts.googleapis.com/css?family=Open+Sans:400" rel="stylesheet">

    <style>
        body {
            font-family: 'Open Sans', sans-serif;
            color: #fff;
            background: #0f1223;
        }
        .svgLogo {
            display: block;
            margin: 50px auto;
            width: 200px;
            max-width: 90%;
            height: auto;
        }
        h1 {
            font-family: 'Open Sans', sans-serif;
            margin : 30px auto;
            color: #c50c1f;
        }
        .desc {
            font-size: 20px;
            font-weight: 500;
        }

        .wrapMsg {
            padding: 50px 15px;
            text-align: center;
            color: #0f1223;
            background: #fff;
        }

        @media (min-width: 768px) {
            .svgLogo {
                margin: 150px auto 60px auto;
                width: 360px;
            }
            h1 {
                font-size: 50px;
            }
            .wrapMsg {
                padding: 100px 30px;
            }
        }
    </style>

</head>
<body>

    <img src="{$themeFolder}/images/icons/logo.svg" alt="{$SITE_NAME}" class="svg svgLogo img-responsive" />

    <div class="wrapMsg">
        <div class="container">
            <div class="row">
                <div class="col-xs-12">
                    <h1>{txt key="maintenance_title" value="Le site est en cours de maintenance"}</h1>
                    <div class="desc">{txt key="maintenance_desc" value="<p>Merci de votre compréhension</p>"}</div>
                </div>
            </div>
        </div>
    </div>


    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
</body>
</html>