#Utilisation du menu

##Description :
Le but est d'avoir un menu propre coté code et simple pour ne pas être bloqué dans une structure suivant le projet sur lequel on va travailler.

##Fichiers nécessaire :
- assets/js/main.js
- template/parts/menu.tpl
- assets/scss/parts/_navigation.scss

## Utilisation :

###main.js :
- Pour appeler le menu dans le main.js, vous devez utiliser la fonction dediMenu(). Le code est en full Javascript, plus de jQuery.
-  Pour activer l'overlay au passage de la souris en desktop, vous devez appeler la fonction overlaySite(). Cette dernière se chargera de mettre la classe *menuOn* sur le wrapSiteContent.

** /!\ ATTENTION /!\ **  : le code contient une utilisation particulière qui n'est pas encore compatible avec IE et Edge. Il faut donc ne pas supprimer le polyfill tout en bas (il y a un commentaire indiquant le code). Ce polyfill ajoute les fonctionnalités manquantes pour faire fonctionner le code sous IE9+ et Edge.



###_navigation.scss :
Le code est fonctionnel. Plusieurs variables ont été supprimés pour simplifier le code, seulement 3 ont été ajoutés. Toutes les variables en haut du fichier ont été documentées.
Une partie globale du menu se situe au tout début du SCSS. Ce qui touche la partie menu mobile se situe dans media-breakpoint-down(md). La partie tablette dans media-breakpoint-only(md). Et ce qui concerne le desktop dans media-breakpoint-up(lg).

D'une façon globale, le code contient des commentaires d'explication.



###menu.tpl :
Le menu est en dur et sera à dynamiser par les Backs. La détection d'un sous-menu ne se fera plus en JS mais par les Backs lors de la dynamisation dans le tpl.
Voici les éléments important :

- S'il existe un sous-menu, ajouter la classe *hadSubMenu* au li (que ce soit pour le premier niveau ou les suivants) 
- Il y a une distinction entre le *menuLvl1* qui est l'ul de base, *menuLvl2* qui est le sous-menu et le *menuLvl3* qui est le sous-menu du sous-menu. A noter, le menu n'a pas été prévu pour un 4ème niveau mais cela est faisable.
- Par défaut, les sous-menu slide de la gauche vers la droite. 
- Pour activer le dépliage à la place du slide, sur le li qui comporte *hadSubMenu*, ajouter la classe *fold* et sur son ul en dessous la classe *openUnfold*


## Informations complémentaires :
Par défaut : 

- Le menu slide en dessous du header. Si le menu doit passer par dessus le header, ajouter la classe *fullMenuMobile* au body.
- Le sous-menu n'est pas en full (bloqué dans le container). Pour le débloquer, ajouter la classe *fullMenu* au body. 

** /!\ A NOTER /!\ **  : les classes ci-dessus sont cumulables sans problème.

